import * as d3 from 'd3';

const data = {
  name: 'A1',
  children: [
    {
      name: 'B1',
      children: [
        {
          name: 'C1',
          value: 100,
        },
        {
          name: 'C2',
          value: 300,
        },
        {
          name: 'C3',
          value: 200,
        },
      ],
    },
    {
      name: 'B2',
      value: 200,
    },
  ],
};

export const main = (container) => {
  const width = container.clientWidth;
  const height = container.clientHeight;

  const partitionLayout = d3.partition().size([400, 200]);

  const rootNode = d3.hierarchy(data);
  rootNode.sum((d) => d.value);

  partitionLayout(rootNode);

  const svg = d3
    .select(container)
    .selectAll('svg')
    .data([1])
    .join('svg')
    .attr('width', width)
    .attr('height', height);

  svg
    .selectAll('rect')
    .data(rootNode.descendants())
    .join('rect')
    .attr('x', (d) => d.x0)
    .attr('y', (d) => d.y0)
    .attr('width', (d) => d.x1 - d.x0)
    .attr('height', (d) => d.y1 - d.y0)
    .style('fill', '#333')
    .style('opacity', 0.3)
    .style('stroke', 'white');

  svg
    .selectAll('text')
    .data(rootNode.descendants())
    .join('text')
    .attr('x', (d) => d.x0 + 5)
    .attr('y', (d) => d.y0 + 20)
    .text((d) => d.data.name)
    .style('fill', 'white');
};
